#!/bin/sh
. `dirname $0`/../func.sh

init_dev
[ $? -ne 0 ] && exit 1

guess_param

echo " starting gstreamer with $CAM_BW_FMT Source ..."
echo " read $SENSOR_RES (offset x,y=$OFFSET_SENSOR), encode2jpeg and write to file ar052x_mono_image.jpg"
echo " ==========================================================================================="
echo ""
echo " configure CSI1 (CAM1 port) with media_control"
echo " ==============================================="

media-ctl -r
media-ctl -l "'${CAM_ENTITY_NAME}':0->'imx7-mipi-csis.0':0[1]"
media-ctl -l "'imx7-mipi-csis.0':1->'csi':0[1]"
media-ctl -l "'csi':1->'csi capture':0[1]"
#           Camera -> imx7_mipi_csis.0 -> CSI -> CSI capture (/dev/videoX)   

media-ctl -V "'${CAM_ENTITY_NAME}':0 [fmt:${CAM_BW_FMT}/${SENSOR_RES} ${OFFSET_SENSOR}/${SENSOR_RES}]"
media-ctl -V "'imx7-mipi-csis.0':1 [fmt:${CAM_BW_FMT}/${SENSOR_RES}]"
media-ctl -V "'csi':1 [fmt:${CAM_BW_FMT}/${SENSOR_RES} field:none]"

echo ""
echo " configure camera @CAM1 with v4l2_control"
echo " ========================================"

$V4L2_CTRL_CAM1_BW
#v4l2-ctl -d $VID_DEVICE -c dynamic_defect_pixel_correction=0
# enable  dynamic defect pixel correction VM-017
../tools/i2cset_16bit_adr.sh 3 0x36 0x31E0 0x0781


echo ""
echo " start gstreamer"
echo " ==============="

gst-launch-1.0 \
	v4l2src num-buffers=$NUMBER_OF_PIC device=$VID_DEVICE ! \
	video/x-raw,format=GRAY8,depth=8,$FRAME_SIZE ! \
	videoconvert ! \
	jpegenc ! \
	multifilesink location=ar052x_mono_image.jpg